<?php

//require_once( 'field-validators/ValidatorFactory.php');


class FieldValidatorAction extends Action
{

/*
	public static $validatorClassMap = array( 
			'user_email' => 'UserEmailValidator',
			'tracker_url' => 'UniqueTrackerValidator'
	);*/

	function FieldValidatorAction() {
	}

	public function performAction( $pathParts, &$dataCollector, $requestPath)
	{
		$validatorType = requestParam('type');

/*
		$fieldId = $this->getRequestParam('fieldId');
		$validationFieldType = $this->getRequestParam('validationFieldType');
*/
		
		if( isset( $validatorType) && !empty( $validatorType) ){
			
			//THIS should all be done inside Contentigo::loadValidator:
			global $site;
			if( array_key_exists( CSM_FIELD_VALIDATORS, $site) && !empty( $site[ CSM_FIELD_VALIDATORS]) ) {
				//no field validators are defined, not much we can do:
//			if( array_key_exists( $validatorType, FieldValidatorAction::$validatorClassMap) ) {
				//ok lets try and create the validator and validate something:
				$validatorClassName = $site[ CSM_FIELD_VALIDATORS][ $validatorType];
				$fieldValidator = loadValidator( $validatorClassName);

				$args = json_decode( requestParam('args'), true);
		//		$escapedArgs = $model->removeSlashes( $this->getRequestParam('args') );
		//		$args = json_decode( $escapedArgs, true);
				$fieldValue = requestParam('fieldValue');

				$fieldDefinitionArray = array();
				//$message = $validator->validate( $fieldDefinitionArray, $fieldValue);
				$message = $fieldValidator->validate( $fieldValue, $args);

				//should use JSON. 
				//$model->displayDataMap['text'] = $message;
				
				echo $message;
				exit;
			}
		}

		return '{"isValid":false,"reason":"validator_not_found"}';
		//return array( 'status' => SUCCESS);
	}

}
?>